> {-# LANGUAGE UnicodeSyntax, UndecidableInstances #-}

> module FinalCoalgebra
> where

Final coalgebra.

> data Nu f = OutI { out :: f (Nu f) }
>
> instance Show (f (Nu f)) => Show (Nu f) where
>   show (OutI x) = show x
>
> unfold :: (Functor f) => (c -> f c) -> (c -> Nu f)
> unfold c = OutI . fmap (unfold c) . c
