> {-# LANGUAGE UnicodeSyntax, UndecidableInstances #-}

> module Copointed
> where

Cofree copointed functor ([Var]iable and [Con]structor).

> data Copointed f a = At { lab :: a, root :: f a }

Todo: better names.

> instance (Functor f) => Functor (Copointed f) where
>  fmap f (At a x) = At (f a) (fmap f x)
>
> (/\) :: (a -> b) -> (a -> f b) -> (a -> Copointed f b)
> ( f /\ g) x = At (f x) (g x)

Converting between C-coalgebras and B-coalgebras.

> up :: (c -> b c) -> (c -> Copointed b c)
> up a = id /\ a

> down :: (c -> Copointed b c) -> (c -> b c)
> down a = root . a
